<?php
//
//   CF Image Hosting Script v1.3.4
//   -------------------------------
//
//   Author:    codefuture.co.uk
//   Version:   1.3.4
//   Date:      12-Jun-10
//
//   download the latest version from - http://codefuture.co.uk/projects/imagehost1.3/
//   Copyright (c) 2010 codefuture.co.uk
//
////////////////////////////////////////////////////////////////////////////////////

//debug
	//error_reporting(E_ERROR | E_WARNING | E_PARSE | E_NOTICE);
// Hide all error messages from the public
	error_reporting(E_ALL^E_NOTICE);
	ini_set('display_errors', 0);

	include_once('lib/arraydb.class.php');

// Upload directory 
	$DIR_UPLOAD			= 'upload/';
	$DIR_IMAGE			= $DIR_UPLOAD.'images/';
	$DIR_THUMB_MID		= $DIR_UPLOAD.'thumbs/';
	$DIR_THUMB			= $DIR_UPLOAD.'smallthumbs/';
	$DIR_DATA			= $DIR_UPLOAD.'data/';

// DB addresss
	$ADD_DB_IMG			= $DIR_DATA.'imgdb.ihdb';
	$ADD_DB_COUNT		= $DIR_DATA.'imgdbcount.ihdb';
	$ADD_DB_BAN			= $DIR_DATA.'ban.ihdb';
	$ADD_DB_REPORT		= $DIR_DATA.'report.ihdb';
	$ADD_DB_SET			= $DIR_DATA.'settings.cdb';

//load settings
	$setting_db = new array_db($ADD_DB_SET);
	$settings	= $setting_db->fetch_all();

// Make sure the install.php file is deleted for normal usage
	if (file_exists('install.php')){
		include_once('install.php');
		exit();
	}

// upload image size(pixels)
	$IMG_MIN_SIZE = '16';
	$IMG_MAX_SIZE = '1920';

//Small Thumb settins
	$THUMB_OPTION		= 'auto';//crop, auto, exact
	$THUMB_MAX_WIDTH	= 170;
	$THUMB_MAX_HEIGHT	= 170;
	$THUMB_SAVE_EXT		= 'png'; // jpg, png, gif
	$THUMB_QUALITY		= 75; //1-100

//Thumb settins
	$THUMB_MID_OPTION		= 'auto';//crop, auto, exact
	$THUMB_MID_MAX_WIDTH	= 350;
	$THUMB_MID_MAX_HEIGHT	= 350;
	$THUMB_MID_SAVE_EXT		= 'png'; // jpg, png, gif
	$THUMB_MID_QUALITY		= 75; //1-100 

// Image Formats
	$accepted			= array('png', 'jpg', 'jpeg', 'gif', 'bmp');
	$acceptedtyp		= array('image/png', 'image/x-png', 'image/pjpeg', 'image/jpg', 'image/jpeg', 'image/gif', 'image/bmp');
	$types				= implode(", ",$accepted);

//other global var
	$Err='';
	$Suc='';

// AD Color setings
	$GOOGLE_ADS_BG = ($settings['SET_THEME']=='dark'?'191919':($settings['SET_THEME']=='light'?'E6E6E6':'F5F5F5'));
	$GOOGLE_ADS_BO = $GOOGLE_ADS_BG;
	
	$GOOGLE_ADS_GM_BG = ($settings['SET_THEME']=='light'?'EEEEEE':$GOOGLE_ADS_BG);
/*
google_color_border = "<?=$GOOGLE_ADS_BO;?>";
google_color_bg = "<?$GOOGLE_ADS_BG;?>";
google_color_link = "FFFFFF";
google_color_text = "FFFFFF";
google_color_url = "FFFFFF";
*/

/////////////////////////////////////////////////////////////////////////////////////////////
//auto run

// see if we need to reset bandwidth
if($settings['SET_MAX_BANDWIDTH'] !=0){
	if(!file_exists($DIR_DATA.date($settings['SET_BANDWIDTH_RESET']))){
		if(bandwidth_reset()){
			if(savefile(array(),$DIR_DATA.date($settings['SET_BANDWIDTH_RESET']))){
				if(file_exists($DIR_DATA.(date($settings['SET_BANDWIDTH_RESET'])-1))){
					unlink ($DIR_DATA.(date($settings['SET_BANDWIDTH_RESET'])-1));
				}
			}
		}
	}
}

//run auto delete
	autoDeleted();


////////////////////////////////////////////////////////////////////////////////////
// functions
////////////////////////////////////////////////////////////////////////////////////

function savefile($menu_array=array(),$fileaddress){
	if($fp = @fopen($fileaddress, 'w+')){
		fwrite($fp, serialize($menu_array));
		fclose($fp);
		return true;
	}else
		return false;
}

function report_img($id,$ip){
	global	$ADD_DB_IMG,$ADD_DB_REPORT,$settings,$Err,$Suc;

	$id = input($id);
	$ip = input($ip);
	
	$db = new array_db($ADD_DB_IMG);
	if($db -> item_exists('id',$id)){
		$db_report = new array_db($ADD_DB_REPORT);

		if(!$db_report -> item_exists('id',$id)){
			$db_report -> add_row(array('id'=>$id,'date'=>time(),'ip'=> $ip,'count' => 1));
		}else{
			$add_one = $db_report -> fetch_value('id',$id,'count')+1;
			$db_report -> set_value('id',$id,'count',$add_one);
		}
		
		if($db_report -> save_db_now()){
			$Suc .= 'Image has been reported';
			if ($settings['SET_EMAIL_REPORT'] && $settings['SET_CONTACT'] !='') {
				$subject = "Image Reported on ".$settings['SET_TITLE'];
				$message  = "image reported : ".$settings['SET_SITEURL']."/".get_image_address($id,'')." \r\n";
				$message .= "reported on : ".$settings['SET_TITLE']." \r\n";
				$message .= "reported IP : ".$ip." \r\n";
				$message .= "Admin Panel : ".$settings['SET_SITEURL']."/admin.php \r\n";
				$headers = "From:".$settings['SET_CONTACT']." <".$settings['SET_CONTACT'].">";
				mail($settings['SET_CONTACT'],$subject,$message,$headers);
			}
		}else
			$Err .= 'Sorry there was a error reporting this image.';
		return true;
	}
	$Err .='Sorry can not find image you are reporting.';
}

function hotlink($ref=''){
	global $settings;
	$referrer = $ref !='' ? $ref:getenv( "HTTP_REFERER" );
	$ref_address	= explode('/',str_replace('www.', '', str_replace('http://', '',$referrer)));
	$home_address	= explode('/',str_replace('www.', '', str_replace('http://', '',$settings['SET_SITEURL'])));
	if($ref_address[0] == $home_address[0])
		return false;
	return true;
}

function not_max_bandwidth($id){
	global	$settings,$ADD_DB_COUNT;

	if(!hotlink() || $settings['SET_MAX_BANDWIDTH'] == 0)return true;
	$img_var = array('size','thumbsize','sthumbsize');
	$db = new array_db($ADD_DB_COUNT);
	if (!$db->db_not_empty())return true;
	if (($settings['SET_MAX_BANDWIDTH']*1048576) > $db->fetch_value('id',$id,'bandwidth'))
		return true;
	else{
		header('Content-type: image/png');
		readfile('../img/bandwidth.png');
		exit();
	}
	return true; 
}

function bandwidth_reset($id=null){
	global $ADD_DB_COUNT;
	$db = new array_db($ADD_DB_COUNT);
	$done = 0;
	if(!$db->db_not_empty())return true;
	$db_count = $db->fetch_all();
	foreach ($db_count  as $k => $v){
		if($id == null || $id == $v['id']){
			$db_count[$k]['bandwidth'] = 0;
			$done = 1;
			break;
		}
	}
	if($done == 1)
		$db->set_db($db_count);
		if ($db->save_db_now())
			return true;
	return false;
}

function shorturl_url($url){
	$tiny = 'http://B54.in/api/?action=shorturl&format=xml&url='.$url;
	$ch = @curl_init();
	curl_setopt($ch, CURLOPT_URL, $tiny);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	$ShortURL = curl_exec($ch);
	curl_close($ch);
	preg_match('#<shorturl(?:\s+[^>]+)?>(.*?)'.'</shorturl>#s', $ShortURL, $elements);

	return $elements[1];
}

function error_note($myproblem) {
	if($myproblem !='')
		echo '<div id="err" class="notification error"><div><b>An error occured:</b> '.$myproblem.'</div></div>';
}

function success_note($mysuccess) {
	if($mysuccess !='')
		echo '<div id="suc" class="notification success"><div><b>Successfull:</b> '.$mysuccess.'</div></div>';
}

function input($in){
	$in = trim($in);
	if (strlen($in) == 0)
		return;
	return htmlspecialchars(stripslashes($in));
}

function removeSymbols($string) {
	$symbols = array('/','\\','\'','"',',','.','<','>','?',';',':','[',']','{','}','|','=','+','-','_',')','(','*','&','^','%','$','#','@','!','~','`');
	for ($i = 0; $i < count($symbols); $i++) {
		$string = str_replace($symbols[$i],' ',$string);
	}
	return trim($string);
}

function bookmarking($document_url,$document_title){
	$social_sites = array(
		"Digg"				=> "http://digg.com/submit?phase=2&url={url}&title={title}",
		"del.icio.us"		=> "http://del.icio.us/post?url={url}&title={title}",
		"Google Bookmarks"	=> "http://www.google.com/bookmarks/mark?op=edit&bkmk={url}&title={title}",
		"Windows Live"		=> "https://favorites.live.com/quickadd.aspx?url={url}&title={title}",
		"Facebook"			=> "http://www.facebook.com/sharer.php?u={url}&t={title}",
		"StumbleUpon"		=> "http://www.stumbleupon.com/submit?url={url}&title={title}",
		"Twitter"			=> "http://twitter.com/home?status={title} - {url}",
		"Google buzz"		=> "http://www.google.com/reader/link?url={url}&title={title}",
		);

	krsort($social_sites);
	$text = '<div class="bookmarking">';

// write all the social bookmarking links to the page
	foreach($social_sites as $social_site=>$social_url){

	// strip special chars to make a valid icon filename
		$social_icon = strtolower(preg_replace('/[^a-zA-Z0-9]/', '', $social_site));

	// replace vars {title} and {url} in $social_url
		$url = str_replace("{title}",urlencode($document_title),str_replace('{url}',urlencode($document_url),$social_url));

		$text .= ' <a href="'.$url.'" title="Submit to '.$social_site.'" rel="nofollow"><img src="img/'.$social_icon.'.png" alt="Submit to '.$social_site.'" /></a>';
	}
	$text .= '</div>';
	return $text;
}


function get_thumb_address($id,$linktype=""){
	global	$DIR_THUMB,
			$THUMB_SAVE_EXT,
			$settings;

	$fileaddress = $DIR_THUMB.$id.'.'.$THUMB_SAVE_EXT;

	if (file_exists($fileaddress)){
		if (!empty($linktype)){
			if($settings['SET_MOD_REWRITE']){
				return $settings['SET_SITEURL'].'/'.$linktype.'-'.$id.'.'.$THUMB_SAVE_EXT;
			}else{
				return $settings['SET_SITEURL'].'/?'.$linktype.'='.$id;
			}
		}
		elseif (empty($linktype))
			return $fileaddress;
	}
}

function get_thumb_mid_address($id,$linktype=""){
	global	$DIR_THUMB_MID,
			$THUMB_MID_SAVE_EXT,
			$settings;

	$fileaddress = $DIR_THUMB_MID.$id.'.'.$THUMB_MID_SAVE_EXT;

	if (file_exists($fileaddress)){
		if (!empty($linktype)){
			if($settings['SET_MOD_REWRITE']){
				return $settings['SET_SITEURL'].'/'.$linktype.'-'.$id.'.'.$THUMB_MID_SAVE_EXT;
			}else{
				return $settings['SET_SITEURL'].'/?'.$linktype.'='.$id;
			}
		}
		elseif (empty($linktype))
			return $fileaddress;
	}
	return false;
}

function get_image_address($id,$linktype=''){
	global	$DIR_IMAGE,
			$ADD_DB_IMG,
			$settings;
	$db = new array_db($ADD_DB_IMG);
	$ext = $db->fetch_value('id',$id,'ext');
	

	if (isset($ext)){
		$fileaddress = $DIR_IMAGE.$id.'.'.$ext;
		if (file_exists($fileaddress)){
			if (!empty($linktype)){
				if($settings['SET_MOD_REWRITE']){
					return $settings['SET_SITEURL'].'/'.$linktype.'-'.$id.'.'.$ext;
				}else{
					return $settings['SET_SITEURL'].'/?'.$linktype.'='.$id;
				}
			}
			elseif (empty($linktype))
				return $fileaddress;
		}
	}
	return false;
}


function autoDeleted(){
	global	$ADD_DB_COUNT,$ADD_DB_IMG,$settings,$DIR_DATA;

	if(!$settings['SET_AUTO_DELETED'])return;
	if(file_exists($DIR_DATA.'ad'.date($settings['SET_AUTO_DELETED_JUMP'])))return;

//load img counter
	$db = new array_db($ADD_DB_IMG);
	$db_counter = new array_db($ADD_DB_COUNT);

	$db_img = $db -> fetch_all();
	$db_count = $db_counter -> fetch_all();
	foreach ($db_img as $k => $v){
	
		$done = 0;
		if (!empty($db_count)){
			foreach ($db_count as $k_c => $v_c){
			
				if ($v_c['id'] == $v['id']){
					if( round(((time() - $v_c['date']) / 86400),2) >= $settings['SET_AUTO_DELETED_TIME']){
						$done = 1;
						$delete_id[] = array('id' => $v['id'], 'k' => $k);
					}
					break;
				}
			}
		}
		if($done == 0){
			if( round(((time() - $v['added']) / 86400),2) >= $settings['SET_AUTO_DELETED_TIME'])
				$delete_id[] = array('id' => $v['id'], 'k' => $k);
		}
	}

//delete images
//reload img db
	if(!empty($delete_id)){
		foreach ($delete_id as $k => $v){
		//get image id
			$img_del_id = $v['id'];
		// Remove Image
			@unlink(get_image_address($img_del_id,'',$db_img));
		// Remove small thumb
			@unlink(get_thumb_address($img_del_id));
		// Remove thumb
			@unlink(get_thumb_mid_address($img_del_id));
		// Remove link from array
			unset($db_img[$v['k']]);
		}
		$db->set_db($db_img);
		$db->save_db_now();
	}

	if(savefile(array(),$DIR_DATA.'ad'.date($settings['SET_AUTO_DELETED_JUMP']))){
		if(file_exists($DIR_DATA.'ad'.(date($settings['SET_AUTO_DELETED_JUMP'])-1))){
			unlink ($DIR_DATA.'ad'.(date($settings['SET_AUTO_DELETED_JUMP'])-1));
		}
	}
}

function countSave($img_id,$img_typ){
	global $ADD_DB_COUNT,$ADD_DB_IMG;

	$db = new array_db($ADD_DB_COUNT);
	$db_img = new array_db($ADD_DB_IMG);
	$image_typ = ($img_typ == 1 ? 'image':($img_typ == 2 ? 'thumb_mid':($img_typ == 3 ? 'thumb':'gallery')));
	$image_bandwidth = $db_img->fetch_value('id',$img_id,($img_typ == 1 ? 'size':($img_typ == 2 ? 'thumbsize':'sthumbsize')));

	if ($db->item_exists('id',$img_id)){
		if ($img_typ == 1) $db -> set_value('id',$img_id,'date',time());
		$count = $db -> fetch_value('id',$img_id,$image_typ)+1;
		$db -> set_value('id',$img_id,$image_typ,$count);
		if($img_typ!=4){
			$new_bw = $db -> fetch_value('id',$img_id,'bandwidth') + $image_bandwidth;
			$db -> set_value('id',$img_id,'bandwidth',$new_bw);
		}
	}else{
		$newdb = array(	'id'		=> $img_id,
						'date'		=> time(),
						'image'		=> ($img_typ == 1 ? 1:0),
						'thumb_mid'	=> ($img_typ == 2 ? 1:0),
						'thumb'		=> ($img_typ == 3 ? 1:0),
						'gallery'	=> ($img_typ == 4 ? 1:0),
						'bandwidth'	=> $image_bandwidth,
					);
		$db->add_row($newdb);
	}
	if ($db->save_db_now())
		return true;
}

function format_size($size="",$file="") {
	if (empty($size) && !empty($file)) $size = @filesize($file);

	if (strlen($size) <= 9 && strlen($size) >= 7){
		$img_size = substr(number_format($size / 1048576,2), -2) == '00' 
					? number_format($size / 1048576,0):number_format($size / 1048576,2);
		$img_size .= " MB";
	}elseif (strlen($size) >= 10){
		$img_size = substr(number_format($size / 1073741824,2), -2) == '00' 
					? number_format($size / 1073741824,0):number_format($size / 1073741824,2);
		$img_size .= " GB";
	}else $img_size = number_format($size / 1024,0)." kb";

	return $img_size;
}

function checklogin() {
	global $settings;
	if(isset($_SESSION['loggedin'])){
		if ($_SESSION['set_name'] == md5($settings['SET_USERNAME'].$settings['SET_SALTING'])){
			return true;
		}else{
			session_unset();
			session_destroy();
		}
	}
	return false;
}

function pagination($page_number,$items_on_page,$item_count,$page_name="",$ex_var=""){
	global $settings;

	$link_mod	= (!$settings['SET_MOD_REWRITE'] ? '?p=':( $page_name =='' ? 'page':'?p='));
	$ex_var		= (!$settings['SET_MOD_REWRITE'] ? $ex_var:( $page_name =='' ? '.html':$ex_var));

	$number_of_pages = ceil($item_count/$items_on_page);
	if (($number_of_pages*$items_on_page) < $item_count) $number_of_pages++;

	$pagination ='<div class="pagination">';
	$pagination .=($page_number>0 ? '<a href="'.$page_name.$link_mod.($page_number).$ex_var.'"><< Previous</a>':'<span class="disabled"><< Previous</span>');

	for ($i = 1; $i <= $number_of_pages; $i++) {
		if($i>($page_number-4) && $i<($page_number+5)){
			$pagination .=($i==$page_number+1 ? '<span class="current">'.$i.'</span>':'<a href="'.$page_name.$link_mod.$i.$ex_var.'">'.$i.'</a>');
		}else if($i<($page_number-3)){
			$pagination .='<a href="'.$page_name.$link_mod.'1'.$ex_var.'">1</a>...';
			$i=$page_number-3;
		}else if($i>($page_number+4)){
			if ($i !=($number_of_pages)) $pagination .='...';
			$pagination .='<a href="'.$page_name.$link_mod.($number_of_pages).$ex_var.'">'.($number_of_pages).'</a>';
			$i=$number_of_pages;
		}
	}

	$pagination .=($page_number<($number_of_pages-1) ? '<a href="'.$page_name.$link_mod.($page_number+2).$ex_var.'">Next >></a>':'<span class="disabled">Next >></span>');
	$pagination .='</div>';
	return $pagination;
}

////////////////////////////////////////////////////////////////////////////////////
// Start session
	session_name();
	if (!session_start()) {
		$Err ='Cannot start a new PHP session. Please contact server administrator or webmaster!';
	}
?>