<?php
//
//   CF Image Hosting Script v1.3
//   -------------------------------
//
//   Author:    codefuture.co.uk
//   Version:   1.3
//   Date:      26-Apr-10
//
//   download the latest version from - http://codefuture.co.uk/projects/imagehost1.3/
//   Copyright (c) 2010 codefuture.co.uk
//
////////////////////////////////////////////////////////////////////////////////////

	include_once('inc/config.php');

	if($settings['SET_HIDE_SEARCH']){
		header('Location: index.php');
		exit();
	}

////////////////////////////////////////////////////////////////////////////////////
// gallerie start

	// see what page we are on
		$page_number = (isset($_GET['p']) ? input($_GET['p'])-1:0);// 0=1st

		$db = new array_db($ADD_DB_IMG);
		$db_found = new array_db();

//////////////////////////////////////////////////

	if( !empty ( $_GET['search'] ) ){
		$string = input($_GET['search']);
		$clean_string = new cleaner();
		$stemmed_string = $clean_string->parseString($string);

		if(!empty($stemmed_string)){

			$new_string = '';
			foreach ( array_unique ( split ( " ",$stemmed_string ) ) as $array => $value ){
				if(strlen($value) >= 3)
					$new_string .= ''.$value.' ';
			}
			$new_string = substr ( $new_string,0, ( strLen ( $new_string ) -1 ) );
			if ( strlen ( $new_string ) > 3 ){
				$db_found->set_db($db->db_search($new_string,array('alt','name')));
			}else//strlen more them 3
				$Err .= 'لطفا بيشتر از سه حرف وارد نماييد';
		}
	}else//search is not empty
		$Err .= 'you did not enter any think to search for';

///////////////////////////////////////////////////

	// count images in db to see if we need to make a page
		if($db_found->db_not_empty()){

		// workout start - stop
			$img_star_on	= $page_number*$settings['SET_IMG_ON_PAGE'];
			$img_end_on		= (($img_star_on+$settings['SET_IMG_ON_PAGE'])>$db_found->db_count() ? $db_found->db_count() : $img_star_on+$settings['SET_IMG_ON_PAGE']);

		// page pagination
			$pagination		= pagination($page_number, $settings['SET_IMG_ON_PAGE'], $db_found->db_count());

		// order image db by new to old
			$db_found->order_by('added',321);

		// make gallery
			$img_gallery ='<ul class="gallery">';
			for ($i = $img_star_on; $i < $img_end_on; $i++) {

				$db_img = $db_found->fetch_key_value($i);

			// page var
				$thumb_mid_link	= get_thumb_mid_address($db_img['id'],"pm",$db_img); 
				$thumb_url		= get_thumb_address($db_img['id'],"dt",$db_img);

			//see if there is a alt(title) if not use the image name
				$alt_text = ($db_img['alt'] !="" ? $db_img['alt']:$db_img['name']);

			//image list for page
				$img_gallery .= '<li><a href="'.$thumb_mid_link.'" title="'.$alt_text.'" class="thumb" >
								<img src="'.$thumb_url.'" alt="'.$alt_text.'"/>
								</a><h2><a href="'.$thumb_mid_link.'" title="'.$alt_text.'">'.$alt_text.'</a></h2></li>';

			}
			$img_gallery .= '</ul>'.$pagination;

		}//end db image count


// gallerie end
////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////
// MAKE PAGE END

	$menu = 'gallery';
	$page_title = $page_number == 0 ? ' - جستجوي تصاوير براي '.$string.' صفحه 1':' - جستجوي تصاوير براي '.$string.' صفحه '.($page_number+1);
	include_once('header.php');
		echo error_note($Err);
		
		if (isset($img_gallery)){
			echo '<h4>Found <span class="search_for">'.$db_found->db_count().'</span> نتايج جستجوي <span class="search_for">'.$string.'</span></h4>';
			echo $img_gallery;
		}else{
			echo '<h4>متاسفانه جستجوي شما با عنوان  <span class="search_for">'.$string.'</span> هيچ نتيجه اي نداشت</h4>';

		}

	include_once('footer.php');

// MAKE PAGE END
////////////////////////////////////////////////////////////////////////////////////

class Cleaner {

	var $stopwords = array(" find ", " about ", " me ", " ever ", " each ", " the ", " jpg ", " gif ", " png ", " bmp ");//you need to extend this big time.
	var $symbols = array('/','\\','\'','"',',','.','<','>','?',';',':','[',']','{','}','|','=','+','-','_',')','(','*','&','^','%','$','#','@','!','~','`'	);//this will remove punctuation

	function parseString($string) {
		$string = ' '.$string.' ';
		$string = $this->removeStopwords($string);
		$string = $this->removeSymbols($string);
		return $string;
	}
	
	function removeStopwords($string) {
		for ($i = 0; $i < sizeof($this->stopwords); $i++) {
			$string = str_replace($this->stopwords[$i],' ',$string);
		}

		return trim($string);
	}

	function removeSymbols($string) {
		for ($i = 0; $i < sizeof($this->symbols); $i++) {
			$string = str_replace($this->symbols[$i],' ',$string);
		}

		return trim($string);
	}
}


?>